Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1319)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -44,27 +50,4 @@
 ! 978 2012-08-09 08:28:32Z fricke
 ! +z0h*
-!
-! 790 2011-11-29 03:11:20Z raasch
-! bugfix: calculation of 'pr' must depend on the particle weighting factor
-!
-! 771 2011-10-27 10:56:21Z heinze
-! +lpt_av
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-!
-! 402 2009-10-21 11:59:41Z maronga
-! Bugfix in calculation of shf*_av, qsws*_av
-!
-! 2009-08-25 08:35:52Z maronga
-! +shf*, qsws*
-!
-! 96 2007-06-04 08:07:41Z raasch
-! +sum-up of density and salinity
-!
-! 72 2007-03-19 08:20:46Z raasch
-! +sum-up of precipitation rate and roughness length (prr*, z0*)
-!
-! RCS Log replace by Id keyword, revision history cleaned up
 !
 ! Revision 1.1  2006/02/23 12:55:23  raasch
@@ -78,18 +61,43 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE averaging
-    USE cloud_parameters
-    USE control_parameters
-    USE cpulog
-    USE indices
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  dzw, e, nr, p, pt, q, qc, ql, ql_c, ql_v, qr, qsws, rho, sa,    &
+               shf, ts, u, us, v, vpt, w, z0, z0h
+
+    USE averaging,                                                             &
+        ONLY:  e_av, lpt_av, lwp_av, nr_av, p_av, pc_av, pr_av, prr_av,        &
+               precipitation_rate_av, pt_av, q_av, qc_av, ql_av, ql_c_av,      &
+               ql_v_av, ql_vp_av, qr_av, qsws_av, qv_av, rho_av, s_av, sa_av,  &
+               shf_av, ts_av, u_av, us_av, v_av, vpt_av, w_av, z0_av, z0h_av
+
+    USE cloud_parameters,                                                      &
+        ONLY:  l_d_cp, precipitation_rate, pt_d_t 
+
+    USE control_parameters,                                                    &
+        ONLY:  average_count_3d, cloud_physics, doav, doav_n
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt 
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  particles, prt_count, prt_start_index
 
     IMPLICIT NONE
 
-    INTEGER ::  i, ii, j, k, n, psi
-
-    REAL    ::  mean_r, s_r3, s_r4
-
+    INTEGER(iwp) ::  i   !: 
+    INTEGER(iwp) ::  ii  !: 
+    INTEGER(iwp) ::  j   !: 
+    INTEGER(iwp) ::  k   !: 
+    INTEGER(iwp) ::  n   !: 
+    INTEGER(iwp) ::  psi !: 
+
+    REAL(wp)     ::  mean_r !: 
+    REAL(wp)     ::  s_r3   !: 
+    REAL(wp)     ::  s_r4   !: 
 
     CALL cpu_log (log_point(34),'sum_up_3d_data','start')
Index: /palm/trunk/SOURCE/surface_coupler.f90
===================================================================
--- /palm/trunk/SOURCE/surface_coupler.f90	(revision 1319)
+++ /palm/trunk/SOURCE/surface_coupler.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -37,20 +43,4 @@
 ! 880 2012-04-13 06:28:59Z raasch
 ! Bugfix: preprocessor statements for parallel execution added
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Additional case for nonequivalent processor and grid topopolgy in ocean and 
-! atmosphere added (coupling_topology = 1).
-! Added exchange of u and v from Ocean to Atmosphere
-!
-! 291 2009-04-16 12:07:26Z raasch
-! Coupling with independent precursor runs.
-! Output of messages replaced by message handling routine.
-!
-! 206 2008-10-13 14:59:11Z raasch
-! Implementation of a MPI-1 Coupling: replaced myid with target_id,
-! deleted __mpi2 directives
 !
 ! 109 2007-08-28 15:26:47Z letzel
@@ -62,15 +52,28 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  pt, shf, qsws, qswst_remote, rho, sa, saswst, total_2d_a,       &
+               total_2d_o, tswst, u, usws, uswst, v, vsws, vswst
+
+    USE control_parameters,                                                    &
+        ONLY:  coupling_mode, coupling_mode_remote, coupling_topology,         &
+               humidity, humidity_remote, message_string, terminate_coupled,   &
+               terminate_coupled_remote, time_since_reference_point
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nx_a, nx_o, ny, nyn, nyng, nys, &
+               nysg, ny_a, ny_o, nzt
+
+    USE kinds
+
     USE pegrid
 
     IMPLICIT NONE
 
-    REAL    ::  time_since_reference_point_rem
-    REAL    ::  total_2d(-nbgp:ny+nbgp,-nbgp:nx+nbgp)
+    REAL(wp)    ::  time_since_reference_point_rem        !: 
+    REAL(wp)    ::  total_2d(-nbgp:ny+nbgp,-nbgp:nx+nbgp) !: 
 
 #if defined( __parallel )
@@ -418,14 +421,28 @@
 #if defined( __parallel )
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE pegrid
+    USE arrays_3d,                                                             &
+        ONLY:  total_2d_a, total_2d_o
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nx_a, nx_o, ny, ny_a, ny_o
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  comm2d, comm_inter, ierr, MPI_DOUBLE_PRECISION, myid, ngp_a,    &
+               target_id
 
     IMPLICIT NONE
 
-    INTEGER             ::  dnx, dnx2, dny, dny2, i, ii, j, jj
-    INTEGER, intent(in) ::  tag
+    INTEGER(iwp) ::  dnx  !: 
+    INTEGER(iwp) ::  dnx2 !: 
+    INTEGER(iwp) ::  dny  !: 
+    INTEGER(iwp) ::  dny2 !: 
+    INTEGER(iwp) ::  i    !: 
+    INTEGER(iwp) ::  ii   !: 
+    INTEGER(iwp) ::  j    !: 
+    INTEGER(iwp) ::  jj   !: 
+
+    INTEGER(iwp), intent(in) ::  tag !: 
 
     CALL MPI_BARRIER( comm2d, ierr )
@@ -490,16 +507,30 @@
 #if defined( __parallel )
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE pegrid
+    USE arrays_3d,                                                             &
+        ONLY:  total_2d_a, total_2d_o
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nx_a, nx_o, ny, ny_a, ny_o
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  comm2d, comm_inter, ierr, MPI_DOUBLE_PRECISION, myid, ngp_o,    &
+               target_id
 
     IMPLICIT NONE
 
-    INTEGER             ::  dnx, dny, i, ii, j, jj
-    INTEGER, intent(in) ::  tag
-    REAL                ::  fl, fr, myl, myr
-
+    INTEGER(iwp)             ::  dnx !: 
+    INTEGER(iwp)             ::  dny !: 
+    INTEGER(iwp)             ::  i   !: 
+    INTEGER(iwp)             ::  ii  !: 
+    INTEGER(iwp)             ::  j   !: 
+    INTEGER(iwp)             ::  jj  !: 
+    INTEGER(iwp), intent(in) ::  tag !: 
+
+    REAL(wp)                 ::  fl  !: 
+    REAL(wp)                 ::  fr  !: 
+    REAL(wp)                 ::  myl !: 
+    REAL(wp)                 ::  myr !: 
 
     CALL MPI_BARRIER( comm2d, ierr )
Index: /palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- /palm/trunk/SOURCE/swap_timelevel.f90	(revision 1319)
+++ /palm/trunk/SOURCE/swap_timelevel.f90	(revision 1320)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! revision history before 2012 removed,
 !
 ! Former revisions:
@@ -50,21 +51,4 @@
 ! all actions concerning leapfrog scheme removed
 !
-! 102 2007-07-27 09:09:17Z raasch
-! swaping of uswst, vswst included
-!
-! 95 2007-06-02 16:48:38Z raasch
-! Swaping of salinity
-!
-! 75 2007-03-22 09:54:05Z raasch
-! moisture renamed humidity
-!
-! 19 2007-02-23 04:53:48Z raasch
-! Swaping of top fluxes
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.8  2004/01/28 15:28:18  raasch
-! Swaping for Runge-Kutta schemes implemented
-!
 ! Revision 1.1  2000/01/10  10:08:58  10:08:58  raasch (Siegfried Raasch)
 ! Initial revision
@@ -76,7 +60,15 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE cpulog
-    USE control_parameters
+    USE arrays_3d,                                                             &
+        ONLY:  e, e_1, e_2, e_p, nr, nr_1, nr_2, nr_p, pt, pt_1, pt_2, pt_p, q,&
+               q_1, q_2, q_p, qr, qr_1, qr_2, qr_p, sa, sa_1, sa_2, sa_p, u,   &
+               u_1, u_2, u_p, v, v_1, v_2, v_p, w, w_1, w_2, w_p
+
+    USE cpulog,                                                                &
+        ONLY: cpu_log, log_point
+
+    USE control_parameters,                                                    &
+        ONLY:  cloud_physics, constant_diffusion, humidity, icloud_scheme,     &
+               neutral, ocean, passive_scalar, precipitation, timestep_count
 
     IMPLICIT NONE
Index: /palm/trunk/SOURCE/temperton_fft.f90
===================================================================
--- /palm/trunk/SOURCE/temperton_fft.f90	(revision 1319)
+++ /palm/trunk/SOURCE/temperton_fft.f90	(revision 1320)
@@ -4,18 +4,15 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 258 2009-03-13 12:36:03Z heinze
-! Output of messages replaced by message handling routine.
-!
-! Feb. 2007
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.2  2003/04/16 12:49:25  raasch
-! Abort in case of illegal factors
 !
 ! Revision 1.1  2003/03/12 16:41:59  raasch
@@ -28,4 +25,6 @@
 !------------------------------------------------------------------------------!
 
+    USE kinds
+
     IMPLICIT NONE
 
@@ -35,16 +34,16 @@
 
 
-    INTEGER           ::  nfax(10)   !  array used by *fft991*.
-    REAL, ALLOCATABLE ::  trig(:)    !  array used by *fft991*.
+    INTEGER(iwp)          ::  nfax(10)   !: array used by *fft991*.
+    REAL(wp), ALLOCATABLE ::  trig(:)    !: array used by *fft991*.
 
 !
 !-- nfft: maximum length of calls to *fft.
 #if defined( __nec )
-    INTEGER, PARAMETER ::  nfft = 256
+    INTEGER(iwp), PARAMETER ::  nfft = 256  !: 
 #else
-    INTEGER, PARAMETER ::  nfft =  32
+    INTEGER(iwp), PARAMETER ::  nfft =  32  !: 
 #endif
 
-    INTEGER, PARAMETER ::  nout =   6  ! standard output stream
+    INTEGER(iwp), PARAMETER ::  nout =   6  !: standard output stream
 
 CONTAINS
@@ -99,20 +98,45 @@
     ! dimension a(n),work(n),trigs(n),ifax(1)
 
+    USE kinds
 
     IMPLICIT NONE
 
     !  Scalar arguments 
-    INTEGER :: inc, isign, jump, lot, n
+    INTEGER(iwp) ::  inc   !: 
+    INTEGER(iwp) ::  isign !: 
+    INTEGER(iwp) ::  jump  !: 
+    INTEGER(iwp) ::  lot   !: 
+    INTEGER(iwp) ::  n     !: 
 
     !  Array arguments 
-    REAL :: a(*), trigs(*), work(*)
-    INTEGER :: ifax(*)
+    REAL(wp)     ::  a(*)     !: 
+    REAL(wp)     ::  trigs(*) !: 
+    REAL(wp)     ::  work(*)  !: 
+    INTEGER(iwp) ::  ifax(*)  !: 
 
     !  Local scalars: 
-    INTEGER :: i, ia, ibase, ierr, ifac, igo, ii, istart, ix, iz, j, jbase, jj, &
-         &      k, la, nb, nblox, nfax, nvex, nx
+    INTEGER(iwp) ::  i      !: 
+    INTEGER(iwp) ::  ia     !: 
+    INTEGER(iwp) ::  ibase  !: 
+    INTEGER(iwp) ::  ierr   !: 
+    INTEGER(iwp) ::  ifac   !: 
+    INTEGER(iwp) ::  igo    !: 
+    INTEGER(iwp) ::  ii     !: 
+    INTEGER(iwp) ::  istart !: 
+    INTEGER(iwp) ::  ix     !: 
+    INTEGER(iwp) ::  iz     !: 
+    INTEGER(iwp) ::  j      !: 
+    INTEGER(iwp) ::  jbase  !: 
+    INTEGER(iwp) ::  jj     !: 
+    INTEGER(iwp) ::  k      !: 
+    INTEGER(iwp) ::  la     !: 
+    INTEGER(iwp) ::  nb     !: 
+    INTEGER(iwp) ::  nblox  !: 
+    INTEGER(iwp) ::  nfax   !: 
+    INTEGER(iwp) ::  nvex   !: 
+    INTEGER(iwp) ::  nx     !: 
 
     !  Intrinsic functions 
-    INTRINSIC MOD
+!    INTRINSIC MOD
 
 
@@ -316,28 +340,112 @@
     !
 
-    IMPLICIT NONE
+    USE kinds
+
+    IMPLICIT NONE 
 
     !  Scalar arguments 
-    INTEGER :: ierr, ifac, inc1, inc2, inc3, inc4, la, lot, n
+    INTEGER(iwp) ::  ierr !: 
+    INTEGER(iwp) ::  ifac !: 
+    INTEGER(iwp) ::  inc1 !: 
+    INTEGER(iwp) ::  inc2 !: 
+    INTEGER(iwp) ::  inc3 !: 
+    INTEGER(iwp) ::  inc4 !: 
+    INTEGER(iwp) ::  la   !: 
+    INTEGER(iwp) ::  lot  !: 
+    INTEGER(iwp) ::  n    !: 
 
     !  Array arguments 
     ! REAL :: a(n),b(n),c(n),d(n),trigs(n)
-    REAL :: a(*), b(*), c(*), d(*), trigs(*)
-
+    REAL(wp) ::  a(*)     !: 
+    REAL(wp) ::  b(*)     !: 
+    REAL(wp) ::  c(*)     !: 
+    REAL(wp) ::  d(*)     !: 
+    REAL(wp) ::  trigs(*) !:
+ 
     !  Local scalars: 
-    REAL :: a0, a1, a10, a11, a2, a20, a21, a3, a4, a5, a6, b0, b1, b10, b11, &
-         &      b2, b20, b21, b3, b4, b5, b6, c1, c2, c3, c4, c5, qrt5, s1, s2, s3, s4, &
-         &      s5, sin36, sin45, sin60, sin72, z, zqrt5, zsin36, zsin45, zsin60, &
-         &      zsin72
-    INTEGER :: i, ia, ib, ibad, ibase, ic, id, ie, if, ig, igo, ih, iink, ijk, &
-         &      ijump, j, ja, jb, jbase, jc, jd, je, jf, jink, k, kb, kc, kd, ke, kf, &
-         &      kstop, l, m
+    REAL(wp) ::  a0     !: 
+    REAL(wp) ::  a1     !: 
+    REAL(wp) ::  a10    !: 
+    REAL(wp) ::  a11    !: 
+    REAL(wp) ::  a2     !: 
+    REAL(wp) ::  a20    !: 
+    REAL(wp) ::  a21    !: 
+    REAL(wp) ::  a3     !: 
+    REAL(wp) ::  a4     !: 
+    REAL(wp) ::  a5     !: 
+    REAL(wp) ::  a6     !: 
+    REAL(wp) ::  b0     !: 
+    REAL(wp) ::  b1     !: 
+    REAL(wp) ::  b10    !: 
+    REAL(wp) ::  b11    !: 
+    REAL(wp) ::  b2     !: 
+    REAL(wp) ::  b20    !: 
+    REAL(wp) ::  b21    !: 
+    REAL(wp) ::  b3     !: 
+    REAL(wp) ::  b4     !: 
+    REAL(wp) ::  b5     !: 
+    REAL(wp) ::  b6     !: 
+    REAL(wp) ::  c1     !: 
+    REAL(wp) ::  c2     !: 
+    REAL(wp) ::  c3     !: 
+    REAL(wp) ::  c4     !: 
+    REAL(wp) ::  c5     !: 
+    REAL(wp) ::  qrt5   !: 
+    REAL(wp) ::  s1     !: 
+    REAL(wp) ::  s2     !: 
+    REAL(wp) ::  s3     !: 
+    REAL(wp) ::  s4     !: 
+    REAL(wp) ::  s5     !: 
+    REAL(wp) ::  sin36  !: 
+    REAL(wp) ::  sin45  !: 
+    REAL(wp) ::  sin60  !: 
+    REAL(wp) ::  sin72  !: 
+    REAL(wp) ::  z      !: 
+    REAL(wp) ::  zqrt5  !: 
+    REAL(wp) ::  zsin36 !: 
+    REAL(wp) ::  zsin45 !: 
+    REAL(wp) ::  zsin60 !: 
+    REAL(wp) ::  zsin72 !: 
+
+    INTEGER(iwp) ::  i     !: 
+    INTEGER(iwp) ::  ia    !: 
+    INTEGER(iwp) ::  ib    !: 
+    INTEGER(iwp) ::  ibad  !: 
+    INTEGER(iwp) ::  ibase !: 
+    INTEGER(iwp) ::  ic    !: 
+    INTEGER(iwp) ::  id    !: 
+    INTEGER(iwp) ::  ie    !: 
+    INTEGER(iwp) ::  if    !: 
+    INTEGER(iwp) ::  ig    !: 
+    INTEGER(iwp) ::  igo   !: 
+    INTEGER(iwp) ::  ih    !: 
+    INTEGER(iwp) ::  iink  !: 
+    INTEGER(iwp) ::  ijk   !: 
+    INTEGER(iwp) ::  ijump !: 
+    INTEGER(iwp) ::  j     !: 
+    INTEGER(iwp) ::  ja    !: 
+    INTEGER(iwp) ::  jb    !: 
+    INTEGER(iwp) ::  jbase !: 
+    INTEGER(iwp) ::  jc    !: 
+    INTEGER(iwp) ::  jd    !: 
+    INTEGER(iwp) ::  je    !: 
+    INTEGER(iwp) ::  jf    !: 
+    INTEGER(iwp) ::  jink  !: 
+    INTEGER(iwp) ::  k     !: 
+    INTEGER(iwp) ::  kb    !: 
+    INTEGER(iwp) ::  kc    !: 
+    INTEGER(iwp) ::  kd    !: 
+    INTEGER(iwp) ::  ke    !: 
+    INTEGER(iwp) ::  kf    !: 
+    INTEGER(iwp) ::  kstop !: 
+    INTEGER(iwp) ::  l     !: 
+    INTEGER(iwp) ::  m     !: 
 
     !  Intrinsic functions 
-    INTRINSIC REAL, SQRT
+!    INTRINSIC REAL, SQRT
 
     !  Data statements 
-    DATA sin36/0.587785252292473/, sin72/0.951056516295154/, &
-         &      qrt5/0.559016994374947/, sin60/0.866025403784437/
+    DATA sin36/0.587785252292473_wp/, sin72/0.951056516295154_wp/, &
+         &      qrt5/0.559016994374947_wp/, sin60/0.866025403784437_wp/
 
 
@@ -438,5 +546,5 @@
     GO TO 170
 30  CONTINUE
-    z = 1.0/REAL(n)
+    z = 1.0_wp/REAL(n)
     DO l = 1, la
        i = ibase
@@ -551,5 +659,5 @@
     GO TO 170
 60  CONTINUE
-    z = 1.0/REAL(n)
+    z = 1.0_wp/REAL(n)
     zsin60 = z*sin60
     DO l = 1, la
@@ -658,5 +766,5 @@
     IF (jb>jc) GO TO 170
 80  CONTINUE
-    sin45 = SQRT(0.5)
+    sin45 = SQRT(0.5_wp)
     jbase = 0
     DO l = 1, la
@@ -680,5 +788,5 @@
     GO TO 170
 90  CONTINUE
-    z = 1.0/REAL(n)
+    z = 1.0_wp/REAL(n)
     DO l = 1, la
        i = ibase
@@ -843,5 +951,5 @@
     GO TO 170
 120 CONTINUE
-    z = 1.0/REAL(n)
+    z = 1.0_wp/REAL(n)
     zqrt5 = z*qrt5
     zsin36 = z*sin36
@@ -1019,5 +1127,5 @@
     GO TO 170
 150 CONTINUE
-    z = 1.0/REAL(n)
+    z = 1.0_wp/REAL(n)
     zsin60 = z*sin60
     DO l = 1, la
@@ -1062,5 +1170,5 @@
     jd = jc + 2*m*inc2
     je = jd + 2*m*inc2
-    z = 1.0/REAL(n)
+    z = 1.0_wp/REAL(n)
     zsin45 = z*SQRT(0.5)
 
@@ -1105,29 +1213,98 @@
     ! Dimension a(n),b(n),c(n),d(n),trigs(n)
 
+    USE kinds
+
     IMPLICIT NONE
 
     !  Scalar arguments 
-    INTEGER :: ierr, ifac, inc1, inc2, inc3, inc4, la, lot, n
+    INTEGER(iwp) ::  ierr !: 
+    INTEGER(iwp) ::  ifac !: 
+    INTEGER(iwp) ::  inc1 !: 
+    INTEGER(iwp) ::  inc2 !: 
+    INTEGER(iwp) ::  inc3 !: 
+    INTEGER(iwp) ::  inc4 !: 
+    INTEGER(iwp) ::  la   !: 
+    INTEGER(iwp) ::  lot  !: 
+    INTEGER(iwp) ::  n    !: 
 
     !  Array arguments 
-    REAL :: a(*), b(*), c(*), d(*), trigs(*)
+    REAL(wp) ::  a(*)     !: 
+    REAL(wp) ::  b(*)     !: 
+    REAL(wp) ::  c(*)     !: 
+    REAL(wp) ::  d(*)     !: 
+    REAL(wp) ::  trigs(*) !: 
 
     !  Local scalars: 
-    REAL :: c1, c2, c3, c4, c5, qqrt5, qrt5, s1, s2, s3, s4, s5, sin36, sin45, &
-         &      sin60, sin72, ssin36, ssin45, ssin60, ssin72
-    INTEGER :: i, ia, ib, ibad, ibase, ic, id, ie, if, igo, iink, ijk, j, ja, &
-         &      jb, jbase, jc, jd, je, jf, jg, jh, jink, jump, k, kb, kc, kd, ke, kf, &
-         &      kstop, l, m
+    REAL(wp) ::  c1     !: 
+    REAL(wp) ::  c2     !: 
+    REAL(wp) ::  c3     !: 
+    REAL(wp) ::  c4     !: 
+    REAL(wp) ::  c5     !: 
+    REAL(wp) ::  qqrt5  !: 
+    REAL(wp) ::  qrt5   !: 
+    REAL(wp) ::  s1     !: 
+    REAL(wp) ::  s2     !: 
+    REAL(wp) ::  s3     !: 
+    REAL(wp) ::  s4     !: 
+    REAL(wp) ::  s5     !: 
+    REAL(wp) ::  sin36  !: 
+    REAL(wp) ::  sin45  !: 
+    REAL(wp) ::  sin60  !: 
+    REAL(wp) ::  sin72  !: 
+    REAL(wp) ::  ssin36 !: 
+    REAL(wp) ::  ssin45 !: 
+    REAL(wp) ::  ssin60 !: 
+    REAL(wp) ::  ssin72 !: 
+
+    INTEGER(iwp) ::  i     !: 
+    INTEGER(iwp) ::  ia    !: 
+    INTEGER(iwp) ::  ib    !: 
+    INTEGER(iwp) ::  ibad  !: 
+    INTEGER(iwp) ::  ibase !: 
+    INTEGER(iwp) ::  ic    !: 
+    INTEGER(iwp) ::  id    !: 
+    INTEGER(iwp) ::  ie    !: 
+    INTEGER(iwp) ::  if    !: 
+    INTEGER(iwp) ::  igo   !: 
+    INTEGER(iwp) ::  iink  !: 
+    INTEGER(iwp) ::  ijk   !: 
+    INTEGER(iwp) ::  j     !: 
+    INTEGER(iwp) ::  ja    !: 
+    INTEGER(iwp) ::  jb    !: 
+    INTEGER(iwp) ::  jbase !: 
+    INTEGER(iwp) ::  jc    !: 
+    INTEGER(iwp) ::  jd    !: 
+    INTEGER(iwp) ::  je    !: 
+    INTEGER(iwp) ::  jf    !: 
+    INTEGER(iwp) ::  jg    !: 
+    INTEGER(iwp) ::  jh    !: 
+    INTEGER(iwp) ::  jink  !: 
+    INTEGER(iwp) ::  jump  !: 
+    INTEGER(iwp) ::  k     !: 
+    INTEGER(iwp) ::  kb    !: 
+    INTEGER(iwp) ::  kc    !: 
+    INTEGER(iwp) ::  kd    !: 
+    INTEGER(iwp) ::  ke    !: 
+    INTEGER(iwp) ::  kf    !: 
+    INTEGER(iwp) ::  kstop !: 
+    INTEGER(iwp) ::  l     !: 
+    INTEGER(iwp) ::  m     !: 
 
     !  Local arrays: 
-    REAL :: a10(nfft), a11(nfft), a20(nfft), a21(nfft), b10(nfft), b11(nfft), b20(nfft), &
-         &      b21(nfft)
+    REAL(wp) ::  a10(nfft) !: 
+    REAL(wp) ::  a11(nfft) !: 
+    REAL(wp) ::  a20(nfft) !: 
+    REAL(wp) ::  a21(nfft) !: 
+    REAL(wp) ::  b10(nfft) !: 
+    REAL(wp) ::  b11(nfft) !: 
+    REAL(wp) ::  b20(nfft) !: 
+    REAL(wp) ::  b21(nfft) !: 
 
     !  Intrinsic functions 
-    INTRINSIC SQRT
+!    INTRINSIC SQRT
 
     !  Data statements 
-    DATA sin36/0.587785252292473/, sin72/0.951056516295154/, &
-         &      qrt5/0.559016994374947/, sin60/0.866025403784437/
+    DATA sin36/0.587785252292473_wp/, sin72/0.951056516295154_wp/, &
+         &      qrt5/0.559016994374947_wp/, sin60/0.866025403784437_wp/
 
 
@@ -1622,7 +1799,7 @@
     GO TO 170
 120 CONTINUE
-    qqrt5 = 2.0*qrt5
-    ssin36 = 2.0*sin36
-    ssin72 = 2.0*sin72
+    qqrt5 = 2.0_wp*qrt5
+    ssin36 = 2.0_wp*sin36
+    ssin72 = 2.0_wp*sin72
     DO l = 1, la
        i = ibase
@@ -1838,5 +2015,5 @@
     jg = jf + jink
     jh = jg + jink
-    ssin45 = SQRT(2.0)
+    ssin45 = SQRT(2.0_wp)
 
     DO l = 1, la
@@ -1889,25 +2066,38 @@
 
 
-    USE control_parameters
-    USE pegrid
+    USE control_parameters,                                                    &
+        ONLY:  message_string
+
+    USE kinds
 
     IMPLICIT NONE
 
     !  Scalar arguments 
-    INTEGER :: n
+    INTEGER(iwp) ::  n !: 
 
     !  Array arguments 
-    REAL :: trigs(*)
-    INTEGER :: ifax(*)
+    INTEGER(iwp) ::  ifax(*)  !: 
+    REAL(wp)     ::  trigs(*) !: 
+
 
     !  Local scalars: 
-    REAL :: angle, del
-    INTEGER :: i, ifac, ixxx, k, l, nfax, nhl, nil, nu
+    REAL(wp) ::  angle    !: 
+    REAL(wp) ::  del      !: 
+    INTEGER(iwp) ::  i    !: 
+    INTEGER(iwp) ::  ifac !: 
+    INTEGER(iwp) ::  ixxx !: 
+    INTEGER(iwp) ::  k    !: 
+    INTEGER(iwp) ::  l    !: 
+    INTEGER(iwp) ::  nfax !: 
+    INTEGER(iwp) ::  nhl  !: 
+    INTEGER(iwp) ::  nil  !: 
+    INTEGER(iwp) ::  nu   !: 
 
     !  Local arrays: 
-    INTEGER :: jfax(10), lfax(7)
+    INTEGER(iwp) ::  jfax(10) !: 
+    INTEGER(iwp) ::  lfax(7)  !: 
 
     !  Intrinsic functions 
-    INTRINSIC ASIN, COS, MOD, REAL, SIN
+!    INTRINSIC ASIN, COS, MOD, REAL, SIN
 
     !  Data statements 
@@ -1918,5 +2108,5 @@
     ixxx = 1
 
-    del = 4.0*ASIN(1.0)/REAL(n)
+    del = 4.0_wp*ASIN(1.0_wp)/REAL(n)
     nil = 0
     nhl = (n/2) - 1
